SystemOrganization addCategory: #'System-Finalization'!

MessageSend subclass: #ObjectFinalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Finalization'!

!ObjectFinalizer commentStamp: 'jcg 4/27/2010 01:01' prior: 0!
Represents an action that is to be taken when a target object (not referenced by the ObjectFinalizer) is garbage-collected.!

!ObjectFinalizer methodsFor: 'finalization' stamp: 'jcg 1/15/2010 01:37'!
finalize
	"Finalize the resource associated with the receiver. This message should only be sent during the finalization process. There is NO garantuee that the resource associated with the receiver hasn't been free'd before so take care that you don't run into trouble - this all may happen with interrupt priority."
	[self value] on: Error do:[:ex| ex return].
! !

!ObjectFinalizer methodsFor: 'initialize' stamp: 'jcg 1/15/2010 01:36'!
receiver: anObject selector: aSymbol argument: aParameter
	"Not really necessary now that we're a subclass of MessageSend, but we keep it around because existing code might expect it."
	self 
		receiver: anObject;
		selector: aSymbol;
		arguments: (Array with: aParameter).! !

OrderedCollection subclass: #ObjectFinalizerCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Finalization'!

!ObjectFinalizerCollection commentStamp: 'ul 2/26/2010 14:23' prior: 0!
An ObjectFinalizerCollection is simple collection which is intended to hold ObjectFinalizers and be used by WeakRegistry.!

!ObjectFinalizerCollection methodsFor: 'finalization' stamp: 'ul 2/25/2010 16:53'!
finalize
	"Finalize all elements in this collection. The elements are expected to be ObjectFinalizers, but can be any object which understands #finalize."

	self do: #finalize! !

!ObjectFinalizerCollection methodsFor: 'testing' stamp: 'Igor.Stasenko 5/25/2010 04:58'!
hasMultipleExecutors
	^ true! !
